;**********************************************************************
;This is the main ncl program called from the script file set_coord
;
;contact  I. Cionni     i.cionni@niwa.co.nz
;**********************************************************************


  load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl" 
;**********************************************************************
;check that all this function are in the same directory of attribute.ncl
;********************************************************************** 
load "time_conform.ncl"
load "coord_function.ncl"
load "att_function.ncl"
load "global_attribute.ncl"
;**********************************************************************
  begin
;**********************************************************************
      MODEL	=getenv("MODEL")
      dir	=getenv ("inputdir")
      fil_in	=getenv ("fil_out")
      dur	=getenv ("outputdir")
      var_name	=getenv ("var_name")
      source	=getenv ("source")
      contact	=getenv ("contact")
      comment	=getenv("comment")  	
      REF	=getenv ("REF")
      exp_id	=getenv ("exp_id")
      history	=getenv ("history")
      references=getenv ("references")
      field	=getenv ("CCMVal_field")

      print("Resume the information "+field+" "+var_name)

;**********************************************************************
;#########OPEN INPUT AND OUTPUT FILE################################
;**********************************************************************   
        fin  = addfile (fil_in, "r")
  
        fol= "CCMVal2_"+REF+"_"+MODEL+"_"+exp_id+"_"+field+"_"+var_name+".nc"
        system("/bin/rm " +dur+fol )     
 
;=======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================
;Read The variable in the file and check if the time is in there 

;vNames = getfilevarnames (fin)
; print(vNames)
    
;       if (any(nNames.eq."time")) then 
         
;=======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================  
;##########Time Conversion to Absolute time#########################
;=======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================

;         tim=fin->time
;         time=time_conform(tim)
 
;=======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================
;#########Assignement of Global Attribute##############################
;=======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================
        fAtt= True
        fAtt@Conventions        =  "CF-1.1"
	fAtt@title              =  MODEL +" model output prepared for CCMVal Report on the Evaluation of Chemistry Climate Models "
        fAtt@contact          =contact
        fAtt@institution        =  MODEL ; where the original data was produced
        fAtt@source             = source+" see http://www.pa.op.dlr.de/CCMVal/" 
        fAtt@history            =  history
        fAtt@references         =  references
;======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================   	
;              DAILY FIELDS
;======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================
;               T2Ms
;======================================================================

	if (field.eq."T2Ms") then
         tim=fin->time
         time=time_conform(tim)
         var=fin->$var_name$(time|:,lat|:,lon|:)  
        
         lat=fin->lat
         lon=fin->lon
  
        ntim  = dimsizes(time)                ;             
        nlat  = dimsizes(lat)  
    	nlon  = dimsizes(lon)   

        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        time=coord_list("time",time)

        var=var_list(var_name,var)       
        var@cell_methods="time:mean (of calendar months)" 
        fout = addfile (dur+fol,"c")
        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T2Ms: Monthly-mean 2-d atmosphere or land surface data (longitude, latitude, time:month)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
       fileattdef( fout, fAtt )            ; copy file attributes 
     
        dimNames = (/"time", "lat", "lon"/)  
	dimSizes = (/ -1   ,  nlat,  nlon /) 
	dimUnlim = (/ True , False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)

    ;===================================================================

       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","lat","lon"/))      
    ;===================================================================

       filevarattdef(fout,var_name,var)                    ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)
     
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if 

;============================================================================
;***************************************************************************
;============================================================================
;                           T3M
;============================================================================

if (field.eq."T3M") then
         tim=fin->time
         time=time_conform(tim)
               var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 
      
             
        plev=fin->lev
      	lat=fin->lat
        lon=fin->lon
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlev  = dimsizes(plev)           
        nlon  = dimsizes(lon)   
        lon=coord_list("lon",lon)
        lat=coord_list("lat",lat)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)                      
 
        var=var_list(var_name,var) 
         var@cell_methods= "time:mean (of calendar months)"                    
        fout = addfile (dur+fol,"c")
        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
        fAtt               = True            ; assign file attributes   
        fAtt@fields="T3M: Monthly-mean 3-d atmosphere data (longitude, latitude, pressure, time:month) "
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )
       
	fileattdef( fout, fAtt )            ; copy file attributes    
    ;===================================================================
         dimNames= (/"time", "plev", "lat","lon"/) 
	dimSizes = (/ -1   ,  nlev,  nlat, nlon /) 
	dimUnlim = (/ True , False, False,False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
    ;===================================================================
        filevardef(fout, "lon"  ,typeof(lon),"lon")
       filevardef(fout, "lat"  ,typeof(lat),"lat")                          
       filevardef(fout, "plev"  ,typeof(plev),"plev")
       filevardef(fout, "time" ,typeof(time),"time")                           
                             
       filevardef(fout, var_name,typeof(var)  ,(/"time","plev","lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"plev",plev)                       ; copy lat attributes
       filevarattdef(fout,"lat",lat)                       ; copy lon attributes   
       filevarattdef(fout,"lon",lon)
       var@cell_methods="time:mean (of calendar months)"
       setfileoption(fout,"DefineMode",False)
    ;===================================================================
       fout->lon    = (/lon/)
       fout->lat    = (/lat/)
       fout->plev    = (/plev/) 
        fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if
;============================================================================
;***************************************************************************
;============================================================================
;                  T2Mz       
;***************************************************************************
;============================================================================
if (field.eq."T2Mz") then
               tim=fin->time
               time=time_conform(tim)
            ;   yyyymmdd=time_yyyymmdd(time)
        ;       var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 
         var=fin->$var_name$(time|:,lev|:,lat|:) 

        plev=fin->lev
       	nlev= dimsizes(plev)     
        lat=fin->lat
	plev=plev
   
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlev  = dimsizes(plev)   
                 
        lat=coord_list("lat",lat)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)
                        
        var=var_list(var_name,var) 
        var@cell_methods="lon:mean (zonal mean), time:mean (of calendar months)"                
        fout = addfile (dur+fol,"c")
 
        setfileoption(fout,"DefineMode",True)

        fAtt               = True            ; assign file attributes   
        fAtt@fields="T2Mz: Monthly-mean zonal mean 2-d atmosphere or land surface data (latitude, pressure, time:month)"
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
	fileattdef( fout, fAtt )            ; copy file attributes    

        dimNames = (/"time", "plev", "lat"/)  
	dimSizes = (/ -1   ,  nlev,  nlat /) 
	dimUnlim = (/ True , False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)

       filevardef(fout, "lat"  ,typeof(lat),"lat")                          
       filevardef(fout, "plev"  ,typeof(plev),"plev")
       filevardef(fout, "time" ,typeof(time),"time")                           
     ;  filevardef(fout, "yyyymmdd" ,typeof(yyyymmdd),"time")            
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","plev","lat"/))      

       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"plev",plev)                       ; copy lat attributes
       filevarattdef(fout,"lat",lat)                       ; copy lon attributes
      ; filevarattdef(fout,"yyyymmdd",yyyymmdd)                       ; copy lon attributes
        
        setfileoption(fout,"DefineMode",False)

       ;fout->yyyymmdd =(/yyyymmdd/)     
       fout->lat    = (/lat/)
       fout->plev    = (/plev/) 
       fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if
;============================================================================
;***************************************************************************
;===========================================================================
;                        T1Ms
;===========================================================================
if (field.eq."T1Ms") then
         tim=fin->time
         time=time_conform(tim)
    ;    var=fin->$var_name$(time|:,lat|:,lon|:,lev|:) 
         var=fin->$var_name$(time|:,lat|:) 
        lat=fin->lat	       
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat) 
        lat=coord_list("lat",lat)
        time=coord_list("time",time)
        
        var=var_list(var_name,var) 
        var@cell_methods="lon:mean (zonal mean), time:mean (of calendar months)"                        
        fout = addfile (dur+fol,"c")
;===================================================================
; explicitly declare file definition mode. Improve efficiency.
;===================================================================
        setfileoption(fout,"DefineMode",True)

;===================================================================
; create global attributes of the file
;===================================================================
        fAtt               = True            ; assign file attributes
         fAtt@fields="T1Ms: Monthly-mean 1-d atmosphere or land surface data on a certain pressure level (latitude, time:month)"
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )

       
	fileattdef( fout, fAtt )            ; copy file attributes    
 
        dimNames = (/"time", "lat"/)  
	dimSizes = (/ -1   ,  nlat /) 
	dimUnlim = (/ True , False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)

 
       filevardef(fout, "lat"  ,typeof(lat),"lat") 
       filevardef(fout, "time" ,typeof(time),"time")                           
                                                             
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","lat"/))      

       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attribute
        setfileoption(fout,"DefineMode",False)

            
       fout->lat    = (/lat/)
        fout->time   = (/time/)
       fout->$var_name$      = (/var/)
    
end if

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%% DAILY FIELDS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;============================================================================
;                           T2Ds
;============================================================================
if (field.eq."T2Ds") then
         tim=fin->time
         time=new((/dimsizes(tim)/),typeof(tim))
         time=time_conform(tim)
         var=fin->$var_name$(time|:,lat|:,lon|:)
          ;     var=fin->$var_name$(time|:,lev|:,lat|:,lon|:)
           
   
        
        lat=fin->lat
	lon=fin->lon
 	plev=fin->lev

        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   
	nlev  = dimsizes(plev)

        plev=coord_list("plev",plev)
        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        time=coord_list("time",time)
        var=var_list(var_name,var)       
     var@cell_methods="time:mean (of day)"
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

    ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T2Ds: Daily-mean 2-d atmosphere data (longitude, latitude, time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
   
        dimNames = (/"time", "plev","lat", "lon"/)  
	dimSizes = (/ -1   ,  nlev, nlat,  nlon /) 
	dimUnlim = (/ True ,False, False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
        var@cell_methods="time:mean (of day)"
    ;===================================================================
       filevardef(fout, "plev"  ,typeof(plev),"plev") 
       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name,typeof(var)  ,(/"time","plev","lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var_na
       filevarattdef(fout,"time",time)                     ; copy time attribut
       filevarattdef(fout,"lat",lat)                  ; copy lat attribute
       filevarattdef(fout,"plev",plev)                       ; copy lat attribute
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)
       fout->plev    = (/plev/)
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
print("qui")
       fout->$var_name$     = (/var/)
end if 

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;                           T3D
;======================================================================   

if (field.eq."T3D") then
         tim=fin->time
         time=time_conform(tim)
               var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 
        printVarSummary(var)
        
        
        lat=fin->lat
	lon=fin->lon
        plev=fin->lev 
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlev  = dimsizes(plev)
        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   
   	nlev  = dimsizes(plev)
        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)
        var=var_list(var_name,var)       
       ; var@cell_methods="time:daily" 
       var@cell_methods="time:mean (of day)"
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T3D: Daily-mean 3-d atmosphere data (longitude, latitude, pressure, time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
     
    ;===================================================================

    ; predefine the coordinate variables and their dimensionality
    ; note: to get an UNLIMITED record dimension, we set the dimensionality
    ; to -1 and set the unlimited array to True.
    ;===================================================================
        dimNames = (/"time", "plev","lat","lon"/)  
	dimSizes = (/ -1   , nlev, nlat,  nlon /) 
	dimUnlim = (/ True ,False, False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
       
    ;===================================================================
       filevardef(fout, "plev"  ,typeof(plev),"plev")
       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","plev","lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes       
       filevarattdef(fout,"plev",plev)
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)

       fout->plev    = (/plev/)
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
print("qui")
       fout->$var_name$      = (/var/)
end if 
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;                     T2Dz
;************************************************************************


if (field.eq."T2Dz") then
         tim=fin->time
         time=time_conform(tim)

             ;  var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 

               var=fin->$var_name$(time|:,lev|:,lat|:)
        plev=fin->lev
       	nlev  = dimsizes(plev)
       
        lat=fin->lat
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlev  = dimsizes(plev)           
        printVarSummary(var)         
        lat=coord_list("lat",lat)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)                      
        var=var_list(var_name,var) 
        var@cell_methods="lon:mean (zonal mean) time:mean (of day)"                      
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
        fAtt               = True            ; assign file attributes   
        fAtt@fields="T2Dz: Daily-mean zonal mean 2-d atmosphere  data (latitude, pressure, time:month)"
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )
       
	fileattdef( fout, fAtt )            ; copy file attributes    
       
         printVarSummary (fAtt)

    ;===================================================================
        dimNames =(/"time","plev","lat"/)
	dimSizes = (/ -1   ,  nlev,  nlat /) 
	dimUnlim = (/ True , False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
       
    ;===================================================================

       filevardef(fout, "lat"  ,typeof(lat),"lat")                          
       filevardef(fout, "plev"  ,typeof(plev),"plev")
       filevardef(fout, "time" ,typeof(time),"time")                           
                             
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","plev","lat"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"plev",plev)                       ; copy lat attributes
       filevarattdef(fout,"lat",lat)                       ; copy lon attributes
     
        setfileoption(fout,"DefineMode",False)

    ;===================================================================
 
       fout->lat    = (/lat/)
       fout->plev    = (/plev/) 
       fout->time   = (/time/)
       fout->$var_name$      = (/var(:,:,:,0)/)
end if
;============================================================================
;***************************************************************************

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%% ISTANTANEOUS FIELDS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;============================================================================
;                    T2Is
;=============================================================================

if (field.eq."T2Is") then    
               var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 
                var=fin->$var_name$(time|:,lat|:,lon|:) 
        lat=fin->lat
	lon=fin->lon
 	plev=fin->lev
         tim=fin->time
         time=time_conform(tim)
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   
	nlev  = dimsizes(plev)

        plev=coord_list("plev",plev)
        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        time=coord_list("time",time)
        var=var_list(var_name,var)       
          var@cell_methods="time:istantaneous"
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T2Is: Daily instantaneous 2-d atmosphere data for all years (longitude, latitude, time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
   
        dimNames = (/"time","plev","lat","lon"/)  
	dimSizes = (/ -1,nlev, nlat,nlon/) 
	dimUnlim = (/ True ,False, False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
       
    ;===================================================================
       filevardef(fout, "plev"  ,typeof(plev),"plev") 
       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","plev","lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var_na
       filevarattdef(fout,"time",time)                     ; copy time attribut
       filevarattdef(fout,"lat",lat)                       ; copy lat attribute
       filevarattdef(fout,"plev",plev)                       ; copy lat attribute
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)
       fout->plev   = (/plev/)
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
print("qui")
       fout->$var_name$      = (/var/)
end if 
;############################################################################
;############################################################################
;============================================================================
;                   T3I
;============================================================================
if (field.eq."T3I") then
         tim=fin->time
         time=time_conform(tim)
               var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 

      
        lat=fin->lat
	lon=fin->lon
	lev=fin->lev
 
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   
        nlev  = dimsizes(lev)

        lev=coord_list("lev",lev)
        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        time=coord_list("time",time)
        var=var_list(var_name,var)       
         
        var@cell_methods="time:istantaneous"
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T3I: Daily-instantaneous 3-d atmosphere data for selected years (longitude, latitude, model levels, time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
        dimNames = (/"time", "lev","lat", "lon"/)  
	dimSizes = (/ -1   ,nlev, nlat,  nlon /) 
	dimUnlim = (/ True , False,False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
       
    ;===================================================================
    
       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "lev"  ,typeof(lev),"lev")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name,typeof(var)  ,(/"time","lev","lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lev",lev)                       ; copy lat attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)
       fout->lev   = (/lev/)
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
print("qui")
       fout->$var_name$     = (/var/)
end if 


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

if (field.eq."T2Iz") then
         tim=fin->time
         time=time_conform(tim)

            ;   var=fin->$var_name$(time|:,lev|:,lat|:,lon|:) 
   
          var=fin->$var_name$(time|:,lev|:,lat|:) 
          
            
        plev=fin->lev
       	nlev  = dimsizes(plev)
       
       
        lat=fin->lat

        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)  
	nlev  = dimsizes(plev)           
        printVarSummary(var)         
        lat=coord_list("lat",lat)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)                      
        var=var_list(var_name,var) 
       var@cell_methods="lon: mean (zonal mean)"                                  
        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
        fAtt               = True            ; assign file attributes   
        fAtt@fields="T2Iz: Daily instantaneous zonal mean 2-d atmosphere data for all years (latitude, pressure, time:day)"
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )
	fileattdef( fout, fAtt )            ; copy file attributes    
        printVarSummary (fAtt)
    ;===================================================================
        dimNames =(/"time","plev","lat"/)
	dimSizes = (/ -1   ,  nlev,  nlat /) 
	dimUnlim = (/ True , False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
        var@cell_methods="time:istantaneous"
    ;===================================================================

       filevardef(fout, "lat"  ,typeof(lat),"lat")                          
       filevardef(fout, "plev"  ,typeof(plev),"plev")
       filevardef(fout, "time" ,typeof(time),"time")                           
                             
       filevardef(fout, var_name,typeof(var)  ,(/"time","plev","lat"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"plev",plev)                       ; copy lat attributes
       filevarattdef(fout,"lat",lat)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)

    ;===================================================================
 
       fout->lat    = (/lat/)
       fout->plev    = (/plev/) 
        fout->time   = (/time/)
print("qui")
       fout->$var_name$      = (/var(:,:,:,0)/)
end if
;============================================================================
;***************************************************************************

;======================================================================   	


if (field.eq."T1Iz") then
                tim=fin->time
               time=time_conform(tim)
              ; var=fin->$var_name$(time|:,lev|:,lat|:) 
    var=fin->$var_name$(time|:,lat|:)
        lat=fin->lat
	plev=fin->lev

        ntim  = dimsizes(time)                ; get dimension sizes            
        nlev  = dimsizes(lev)
        nlat  = dimsizes(lat)     
   	nlev  = dimsizes(lev)
       
        lat=coord_list("lat",lat)
        plev=coord_list("plev",plev)
        time=coord_list("time",time)
        var=var_list(var_name,var)       
            var@cell_methods="time:istantaneous"

        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T1Iz: Daily instantaneous 1-d field for all years (latitude-pressure, time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
     
    ;===================================================================
    ; predefine the coordinate variables and their dimensionality
    ; note: to get an UNLIMITED record dimension, we set the dimensionality
    ; to -1 and set the unlimited array to True.
    ;===================================================================
        dimNames = (/"time", "plev","lat"/)  
	dimSizes = (/ -1   , nlev, nlat /) 
	dimUnlim = (/ True ,False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
        
    ;===================================================================
       filevardef(fout, "plev"  ,typeof(lev),"lev") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name,typeof(var)  ,(/"time","plev","lat"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes       filevarattdef(fout,"lev",plev)
        setfileoption(fout,"DefineMode",False)

       fout->plev    = (/plev/)
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if 

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
if (field.eq."T0I") then
                tim=fin->time
               time=time_conform(tim)
               var=fin->$var_name$(time|:) 
   
       


        ntim  = dimsizes(time)                ; get dimension sizes            
       
       
        
        time=coord_list("time",time)
        var=var_list(var_name,var)       
         var@cell_methods="time:istantaneous"

        fout = addfile (dur+fol,"c")

        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="T0I: Daily instantaneous 0-d field for all years (time:day)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
     
    ;===================================================================
    ; predefine the coordinate variables and their dimensionality
    ; note: to get an UNLIMITED record dimension, we set the dimensionality
    ; to -1 and set the unlimited array to True.
    ;===================================================================
        dimNames = (/"time"/)  
	dimSizes = (/ -1  /) 
	dimUnlim = (/ True /)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
        
    ;===================================================================
     
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name,typeof(var)  ,(/"time"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes

        setfileoption(fout,"DefineMode",False)

 
       fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if 

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

if (field.eq."T0As") then
         tim=fin->time
         time=time_conform(tim)
    ;     var=fin->$var_name$(time|:,lat|:,lon|:) 
          var=fin->$var_name$(time|:,lat|:) 
              
        lat=fin->lat
        ntim  = dimsizes(time)                ; get dimension sizes            
        nlat  = dimsizes(lat)             
        lat=coord_list("lat",lat)     
        time=coord_list("time",time) 
                            
        var=var_list(var_name,var) 
    var@cell_methods="time:mean (of year)"                               
        fout = addfile (dur+fol,"c")
        setfileoption(fout,"DefineMode",True)
  
     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
        fAtt               = True            ; assign file attributes   
        fAtt@fields="T0As: Annual-mean 0-d atmosphere or land surface data on a certain pressure level (latitude, time:year)"
        global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )
       
	fileattdef( fout, fAtt )            ; copy file attributes    
       
         printVarSummary (fAtt)

    ;===================================================================
        dimNames = (/"time","lat"/)
	dimSizes = (/ -1   ,  nlat /) 
	dimUnlim = (/ True , False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
          
    ;===================================================================

       filevardef(fout, "lat"  ,typeof(lat),"lat")                          
       filevardef(fout, "time" ,typeof(time),"time")                           
                             
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","lat"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)

    ;===================================================================
 
        fout->lat    = (/lat/)
        fout->time   = (/time/)
        fout->$var_name$      = (/var/)
end if
;============================================================================
;**************************************************************

;======================================================================
;//////////////////////////////////////////////////////////////////
;======================================================================   	


if (field.eq."F2Ms") then
        var=fin->$var_name$(time|:,lat|:,lon|:) 
        lat=fin->lat
        lon=fin->lon
 

        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   
      
        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
       
        var=var_list(var_name,var)     
        fout = addfile (dur+fol,"c")
        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="F2Ms: 2D Time indipendent land surface data Latitude-Longitude"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
        fileattdef( fout, fAtt )            ; copy file attributes 
     
    ;===================================================================
    ; predefine the coordinate variables and their dimensionality
    ; note: to get an UNLIMITED record dimension, we set the dimensionality
    ; to -1 and set the unlimited array to True.
    ;===================================================================
        dimNames = (/"lat","lon"/)  
	dimSizes = (/ nlat,  nlon /) 
	dimUnlim = (/ False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)

    ;===================================================================
       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
                                     
       filevardef(fout, var_name,typeof(var)  ,(/"lat","lon"/))      
    ;===================================================================
    ; Copy attributes associated with each variable to the file
    ; All attributes associated with each variable will be copied.
    ;====================================================================
       filevarattdef(fout,var_name,var)                           ; copy vary attributes
      
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes 
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)

       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
      
print("qui")
       fout->$var_name$      = (/var(0,:,:)/)
end if 
;======================================================================
;               TO2Ms
;======================================================================

	if (field.eq."TO2Ms") then
         tim=fin->time
         time=time_conform(tim)
        var=fin->$var_name$(time|:,lat|:,lon|:)  
        
        lat=fin->lat
        lon=fin->lon
  
        ntim  = dimsizes(time)                ;             
        nlat  = dimsizes(lat)  
	nlon  = dimsizes(lon)   

        lat=coord_list("lat",lat)
        lon=coord_list("lon",lon)
        time=coord_list("time",time)

        var=var_list(var_name,var)       
        var@cell_methods="time:mean (of calendar months)" 
        fout = addfile (dur+fol,"c")
        setfileoption(fout,"DefineMode",True)

     ;===================================================================
    ; create global attributes of the file
    ;===================================================================
       fAtt               = True            ; assign file attributes
       fAtt@fields="TO2Ms: Monthly-mean 2-d ocean or sea ice data (longitude, latitude, time:month)"
       global_attribute ( MODEL,references,contact,REF,exp_id,history,comment,source,fAtt )       
       fileattdef( fout, fAtt )            ; copy file attributes 
     
        dimNames = (/"time", "lat", "lon"/)  
	dimSizes = (/ -1   ,  nlat,  nlon /) 
	dimUnlim = (/ True , False, False/)   
	filedimdef(fout,dimNames,dimSizes,dimUnlim)
        var@cell_methods="time:mean (calendar month)"
    ;===================================================================

       filevardef(fout, "lon"  ,typeof(lon),"lon") 
       filevardef(fout, "lat"  ,typeof(lat),"lat")
       filevardef(fout, "time" ,typeof(time),"time")        
                      
       filevardef(fout, var_name  ,typeof(var)  ,(/"time","lat","lon"/))      
    ;===================================================================

       filevarattdef(fout,var_name,var)                    ; copy var attributes
       filevarattdef(fout,"time",time)                     ; copy time attributes
       filevarattdef(fout,"lat",lat)                       ; copy lat attributes
       filevarattdef(fout,"lon",lon)                       ; copy lon attribute
        setfileoption(fout,"DefineMode",False)
     
       fout->lon    = (/lon/)  
       fout->lat    = (/lat/) 
       fout->time   = (/time/)
       fout->$var_name$      = (/var/)
end if 

tot_field=(/"T2Ms","T3M","T2Mz","T1Ms","T2Ds","T3D","T2Dz","T2Is","T3I","T2Iz","T0I","T0As","TO2Ms"/)

if (all(tot_field.ne.field)) then 
print(field + " is wrong CCMVal field name: please check your setting!")
end if 

end
